Index: NEWS
===================================================================
RCS file: /cvs/root/wanderlust/NEWS,v
retrieving revision 1.69.2.1
retrieving revision 1.69.2.2
diff -u -r1.69.2.1 -r1.69.2.2
--- NEWS	21 Mar 2005 04:34:07 -0000	1.69.2.1
+++ NEWS	3 Apr 2005 06:16:33 -0000	1.69.2.2
@@ -1,5 +1,12 @@
 Wanderlust NEWS -- User-visible changes in Wanderlust.
 
+* Changes in 2.14.1 from 2.14.0
+  Version 2.14.1 is a bug fix version of 2.14.0.
+
+** Fixed message order of Maildir.
+
+** Icon for the access folder is displayed.
+
 * Changes in 2.14.0 from 2.12.2
 
 ** New folder type `access' is added.
Index: NEWS.ja
===================================================================
RCS file: /cvs/root/wanderlust/NEWS.ja,v
retrieving revision 1.78.2.1
retrieving revision 1.78.2.2
diff -u -r1.78.2.1 -r1.78.2.2
--- NEWS.ja	21 Mar 2005 04:34:07 -0000	1.78.2.1
+++ NEWS.ja	3 Apr 2005 06:16:33 -0000	1.78.2.2
@@ -1,5 +1,12 @@
 Wanderlust NEWS ($BF|K\8lHG(B) -- User-visible changes in Wanderlust.
 
+* 2.14.0 $B$+$i(B 2.14.1 $B$X$NJQ99E@(B
+  2.14.1 $B$O!"(B2.14.0 $B$N%P%0=$@5HG$G$9!#(B
+
+** Maildir $B$GI=<(=g=x$,@5$7$/$J$$%P%0$,=$@5$5$l$^$7$?!#(B
+
+** $B%"%/%;%9%U%)%k%@$N%"%$%3%s$,I=<($5$l$^$9!#(B
+
 * 2.12.2 $B$+$i(B 2.14.0 $B$X$NJQ99E@(B
 
 ** $B?7$7$$%U%)%k%@7?(B access $B%U%)%k%@$,DI2C$5$l$^$7$?!#(B
Index: doc/version.tex
===================================================================
RCS file: /cvs/root/wanderlust/doc/version.tex,v
retrieving revision 1.52.2.1
retrieving revision 1.52.2.2
diff -u -r1.52.2.1 -r1.52.2.2
--- doc/version.tex	13 Mar 2005 10:19:20 -0000	1.52.2.1
+++ doc/version.tex	1 Apr 2005 12:42:40 -0000	1.52.2.2
@@ -1 +1 @@
-\def\versionnumber{2.14.0}
+\def\versionnumber{2.14.1}
Index: doc/version.texi
===================================================================
RCS file: /cvs/root/wanderlust/doc/version.texi,v
retrieving revision 1.62.2.1
retrieving revision 1.62.2.2
diff -u -r1.62.2.1 -r1.62.2.2
--- doc/version.texi	13 Mar 2005 10:19:20 -0000	1.62.2.1
+++ doc/version.texi	1 Apr 2005 12:42:40 -0000	1.62.2.2
@@ -1 +1 @@
-@set VERSION 2.14.0
+@set VERSION 2.14.1
Index: elmo/ChangeLog
===================================================================
RCS file: /cvs/root/wanderlust/elmo/ChangeLog,v
retrieving revision 1.720.2.4
retrieving revision 1.720.2.8
diff -u -r1.720.2.4 -r1.720.2.8
--- elmo/ChangeLog	25 Mar 2005 14:45:11 -0000	1.720.2.4
+++ elmo/ChangeLog	5 Apr 2005 13:57:49 -0000	1.720.2.8
@@ -1,3 +1,32 @@
+2005-04-05  Yuuichi Teranishi  <teranisi@gohome.org>
+
+	* elmo-maildir.el (elmo-maildir-sequence-number): New function.
+	(elmo-maildir-make-unique-string): Throw Emacs 18 away.
+	(elmo-maildir-list-location): Use `elmo-maildir-sequence-number' to
+	compare sequence number when last modified time is nil.
+
+2005-04-03  Yuuichi Teranishi  <teranisi@gohome.org>
+
+	* elmo-maildir.el (elmo-folder-msgdb-create): Don't sort by date.
+
+	* elmo-shimbun.el (elmo-folder-msgdb-create): Ditto.
+
+2005-04-01  Yuuichi Teranishi  <teranisi@gohome.org>
+
+	* elmo.el (elmo-folder-synchronize): Ignore errors while updating
+	flag table.
+
+	* elmo-maildir.el (elmo-maildir-list-location): Sort by last
+	modification time of the file.
+
+	* elmo-version.el (elmo-version): Up to 2.14.1.
+
+	* elmo.el (elmo-folder-synchronize): Clear msgdb even when an
+	error occured while updating flag table.
+
+	* modb-standard.el (modb-standard-load-entity): Cause an error when
+	entity format is for 2.15.0 or later.
+
 2005-03-25  Yuuichi Teranishi  <teranisi@gohome.org>
 
 	* 2.14.0 is released.
Index: elmo/elmo-maildir.el
===================================================================
RCS file: /cvs/root/wanderlust/elmo/elmo-maildir.el,v
retrieving revision 1.52
retrieving revision 1.52.2.3
diff -u -r1.52 -r1.52.2.3
--- elmo/elmo-maildir.el	19 Feb 2005 03:04:07 -0000	1.52
+++ elmo/elmo-maildir.el	5 Apr 2005 13:57:50 -0000	1.52.2.3
@@ -113,7 +113,19 @@
 	 (cur (directory-files cur-dir
 			       nil "^[^.].*$" t))
 	 unread-locations flagged-locations answered-locations
-	 sym locations flag-list)
+	 sym locations flag-list x-time y-time)
+    (setq cur (sort cur
+		    (lambda (x y)
+		      (setq x-time (elmo-get-last-modification-time
+				    (expand-file-name x cur-dir))
+			    y-time (elmo-get-last-modification-time
+				    (expand-file-name y cur-dir)))
+		      (cond
+		       ((< x-time y-time)
+			t)
+		       ((eq x-time y-time)
+			(< (elmo-maildir-sequence-number x)
+			   (elmo-maildir-sequence-number y)))))))
     (setq locations
 	  (mapcar
 	   (lambda (x)
@@ -241,7 +253,7 @@
 	   'elmo-maildir-msgdb-create "Creating msgdb..."
 	   (/ (* i 100) len)))))
     (message "Creating msgdb...done")
-    (elmo-msgdb-sort-by-date new-msgdb)))
+    new-msgdb))
 
 (defun elmo-maildir-cleanup-temporal (dir)
   ;; Delete files in the tmp dir which are not accessed
@@ -371,36 +383,24 @@
 
 (defvar elmo-maildir-sequence-number-internal 0)
 
-(static-cond
- ((>= emacs-major-version 19)
-  (defun elmo-maildir-make-unique-string ()
-    "This function generates a string that can be used as a unique
-file name for maildir directories."
-     (let ((cur-time (current-time)))
-       (format "%.0f.%d_%d.%s"
- 	      (+ (* (car cur-time)
-                    (float 65536)) (cadr cur-time))
-	      (emacs-pid)
-	      (incf elmo-maildir-sequence-number-internal)
-	      (system-name)))))
- ((eq emacs-major-version 18)
-  ;; A fake function for v18
-  (defun elmo-maildir-make-unique-string ()
-    "This function generates a string that can be used as a unique
+(defun elmo-maildir-sequence-number (file)
+  "Get `elmo-maildir' specific sequence number from FILE.
+Not that FILE is the name without directory."
+  ;; elmo-maildir specific.
+  (if (string-match "^.*_\\([0-9]+\\)\\..*" file)
+      (string-to-number (match-string 1 file))
+    -1))
+
+(defun elmo-maildir-make-unique-string ()
+  "This function generates a string that can be used as a unique
 file name for maildir directories."
-    (unless (fboundp 'float-to-string)
-      (load-library "float"))
-    (let ((time (current-time)))
-      (format "%s%d.%d.%s"
-	      (substring
-	       (float-to-string
-		(f+ (f* (f (car time))
-			(f 65536))
-		    (f (cadr time))))
-	       0 5)
-	      (cadr time)
-	      (% (abs (random t)) 10000); dummy pid
-	      (system-name))))))
+  (let ((cur-time (current-time)))
+    (format "%.0f.%d_%d.%s"
+	    (+ (* (car cur-time)
+		  (float 65536)) (cadr cur-time))
+	    (emacs-pid)
+	    (incf elmo-maildir-sequence-number-internal)
+	    (system-name))))
 
 (defun elmo-maildir-temporal-filename (basedir)
   (let ((filename (expand-file-name
Index: elmo/elmo-shimbun.el
===================================================================
RCS file: /cvs/root/wanderlust/elmo/elmo-shimbun.el,v
retrieving revision 1.49
retrieving revision 1.49.2.1
diff -u -r1.49 -r1.49.2.1
--- elmo/elmo-shimbun.el	5 Mar 2005 03:28:40 -0000	1.49
+++ elmo/elmo-shimbun.el	3 Apr 2005 06:22:55 -0000	1.49.2.1
@@ -368,7 +368,7 @@
 	 percent))
       (setq numlist (cdr numlist)))
     (message "Creating msgdb...done")
-    (elmo-msgdb-sort-by-date new-msgdb)))
+    new-msgdb))
 
 (luna-define-method elmo-folder-message-file-p ((folder elmo-shimbun-folder))
   nil)
Index: elmo/elmo-version.el
===================================================================
RCS file: /cvs/root/wanderlust/elmo/elmo-version.el,v
retrieving revision 1.86.2.1
retrieving revision 1.86.2.2
diff -u -r1.86.2.1 -r1.86.2.2
--- elmo/elmo-version.el	13 Mar 2005 10:19:20 -0000	1.86.2.1
+++ elmo/elmo-version.el	1 Apr 2005 12:42:39 -0000	1.86.2.2
@@ -40,7 +40,7 @@
 ;; product-define in the first place
 (product-provide 'elmo-version
   ;; Don't forget to check `wl-version.el' and Info.
-  (product-define "ELMO" nil '(2 14 0)))
+  (product-define "ELMO" nil '(2 14 1)))
 
 ;; set version-string
 (product-version-as-string 'elmo-version)
Index: elmo/elmo.el
===================================================================
RCS file: /cvs/root/wanderlust/elmo/elmo.el,v
retrieving revision 1.153
retrieving revision 1.153.2.2
diff -u -r1.153 -r1.153.2.2
--- elmo/elmo.el	13 Mar 2005 08:39:51 -0000	1.153
+++ elmo/elmo.el	1 Apr 2005 12:42:39 -0000	1.153.2.2
@@ -1533,7 +1533,8 @@
 	(flag-table (elmo-flag-table-load (elmo-folder-msgdb-path folder)))
 	(before-append t))
     (when ignore-msgdb
-      (elmo-msgdb-flag-table (elmo-folder-msgdb folder) flag-table)
+      (ignore-errors
+	(elmo-msgdb-flag-table (elmo-folder-msgdb folder) flag-table))
       (elmo-folder-clear folder (not disable-killed)))
     (unless no-check (elmo-folder-check folder))
     (condition-case nil
Index: elmo/modb-standard.el
===================================================================
RCS file: /cvs/root/wanderlust/elmo/modb-standard.el,v
retrieving revision 1.29
retrieving revision 1.29.2.1
diff -u -r1.29 -r1.29.2.1
--- elmo/modb-standard.el	5 Mar 2005 03:28:40 -0000	1.29
+++ elmo/modb-standard.el	1 Apr 2005 03:06:43 -0000	1.29.2.1
@@ -196,11 +196,14 @@
 (defun modb-standard-load-entity (modb path &optional section)
   (let ((table (or (modb-standard-entity-map-internal modb)
 		   (elmo-make-hash (elmo-msgdb-length modb))))
+	(entities (elmo-object-load
+		   (expand-file-name
+		    (modb-standard-entity-filename section)
+		    path)))
 	number msgid)
-    (dolist (entity (elmo-object-load
-		     (expand-file-name
-		      (modb-standard-entity-filename section)
-		      path)))
+    (when (symbolp (car entities))
+      (error "Unsupported msgdb structure detected. Please re-create msgdb"))
+    (dolist (entity entities)
       (setq number (elmo-msgdb-message-entity-number
 		    (elmo-message-entity-handler entity)
 		    entity)
Index: etc/VERSION
===================================================================
RCS file: /cvs/root/wanderlust/etc/VERSION,v
retrieving revision 1.15.2.1
retrieving revision 1.15.2.2
diff -u -r1.15.2.1 -r1.15.2.2
--- etc/VERSION	13 Mar 2005 10:19:20 -0000	1.15.2.1
+++ etc/VERSION	1 Apr 2005 12:42:39 -0000	1.15.2.2
@@ -135,5 +135,6 @@
 2.13.x  You Oughta Know
 
 2.14.0  Africa
+2.14.1  Bad Medicine
 
 2.15.x  Almost Unreal
\ No newline at end of file
Index: wl/ChangeLog
===================================================================
RCS file: /cvs/root/wanderlust/wl/ChangeLog,v
retrieving revision 1.1157.2.4
retrieving revision 1.1157.2.7
diff -u -r1.1157.2.4 -r1.1157.2.7
--- wl/ChangeLog	25 Mar 2005 14:45:10 -0000	1.1157.2.4
+++ wl/ChangeLog	5 Apr 2005 13:57:50 -0000	1.1157.2.7
@@ -1,3 +1,32 @@
+2005-04-04  Tetsurou Okazaki  <okazaki@be.to>
+
+	* wl-action.el (wl-summary-exec): Reduce loop strength in a dolist loop.
+
+2005-04-03  Hiroya Murata  <lapis-lazuli@pop06.odn.ne.jp>
+
+	* wl-thread.el (wl-thread-delete-message): Delete descendant
+	numbers from `wl-summary-buffer-number-list' if `deep' is non-nil.
+
+2005-04-03  Yuuichi Teranishi  <teranisi@gohome.org>
+
+	* wl-xmas.el (wl-folder-internal-icon-list): Fix last change.
+
+2005-03-27  Yoichi NAKAYAMA  <yoichi@geiin.org>
+
+	* wl-xmas.el (wl-folder-internal-icon-list): Added entry for
+	`Access folder'.
+
+2005-03-27  Hiroya Murata  <lapis-lazuli@pop06.odn.ne.jp>
+
+	* wl-vars.el (wl-access-folder-icon): New user option.
+
+	* wl-e21.el (wl-folder-internal-icon-list): Added entry for
+	`Access folder'.
+
+2005-04-01  Yuuichi Teranishi  <teranisi@gohome.org>
+
+	* Version number is increased to 2.14.1.
+
 2005-03-25  Yuuichi Teranishi  <teranisi@gohome.org>
 
 	* 2.14.0 is released.
Index: wl/wl-action.el
===================================================================
RCS file: /cvs/root/wanderlust/wl/wl-action.el,v
retrieving revision 1.42
retrieving revision 1.42.2.1
diff -u -r1.42 -r1.42.2.1
--- wl/wl-action.el	24 Feb 2005 23:46:00 -0000	1.42
+++ wl/wl-action.el	5 Apr 2005 13:57:50 -0000	1.42.2.1
@@ -682,12 +682,13 @@
     ;; collected is a pair of
     ;; mark-string and a list of mark-info
     (dolist (pair collected)
-      (setq action (assoc (car pair) wl-summary-mark-action-list))
-      (when (and (cdr pair) (wl-summary-action-exec-function action))
-	(setq modified t)
-	(setq failures (+ failures (funcall
-				    (wl-summary-action-exec-function action)
-				    (cdr pair))))))
+      (when (cdr pair)
+	(setq action (assoc (car pair) wl-summary-mark-action-list))
+	(when (wl-summary-action-exec-function action)
+	  (setq modified t)
+	  (setq failures (+ failures (funcall
+				      (wl-summary-action-exec-function action)
+				      (cdr pair)))))))
     (when modified
       (wl-summary-set-message-modified))
     (run-hooks 'wl-summary-exec-hook)
Index: wl/wl-e21.el
===================================================================
RCS file: /cvs/root/wanderlust/wl/wl-e21.el,v
retrieving revision 1.60
retrieving revision 1.60.2.1
diff -u -r1.60 -r1.60.2.1
--- wl/wl-e21.el	15 Dec 2004 14:32:53 -0000	1.60
+++ wl/wl-e21.el	3 Apr 2005 06:16:23 -0000	1.60.2.1
@@ -441,6 +441,7 @@
     (wl-folder-nmz-image	  . wl-nmz-folder-icon)
     (wl-folder-shimbun-image      . wl-shimbun-folder-icon)
     (wl-folder-file-image	  . wl-file-folder-icon)
+    (wl-folder-access-image	  . wl-access-folder-icon)
     (wl-folder-trash-empty-image  . wl-empty-trash-folder-icon)
     (wl-folder-draft-image	  . wl-draft-folder-icon)
     (wl-folder-queue-image	  . wl-queue-folder-icon)
Index: wl/wl-thread.el
===================================================================
RCS file: /cvs/root/wanderlust/wl/wl-thread.el,v
retrieving revision 1.52.2.1
retrieving revision 1.52.2.2
diff -u -r1.52.2.1 -r1.52.2.2
--- wl/wl-thread.el	20 Mar 2005 13:10:02 -0000	1.52.2.1
+++ wl/wl-thread.el	5 Apr 2005 13:57:50 -0000	1.52.2.2
@@ -505,6 +505,12 @@
       (setq wl-summary-buffer-number-list
 	    (delq msg wl-summary-buffer-number-list))
       (when entity
+	(when deep
+	  (setq wl-summary-buffer-number-list
+		(elmo-list-delete
+		 (wl-thread-entity-get-descendant entity)
+		 wl-summary-buffer-number-list
+		 #'delq)))
 	(let ((parent (wl-thread-entity-get-parent-entity entity)))
 	  (if parent
 	      ;; has parent.
Index: wl/wl-vars.el
===================================================================
RCS file: /cvs/root/wanderlust/wl/wl-vars.el,v
retrieving revision 1.213
retrieving revision 1.213.2.1
diff -u -r1.213 -r1.213.2.1
--- wl/wl-vars.el	25 Feb 2005 15:05:50 -0000	1.213
+++ wl/wl-vars.el	3 Apr 2005 06:16:23 -0000	1.213.2.1
@@ -2973,6 +2973,8 @@
   "*Icon file for file folder.")
 (defvar wl-maildir-folder-icon "maildir.xpm"
   "*Icon file for maildir folder.")
+(defvar wl-access-folder-icon "access.xpm"
+  "*Icon file for access folder.")
 (defvar wl-empty-trash-folder-icon "trash-e.xpm"
   "*Icon file for emptied trash folder.")
 (defvar wl-trash-folder-icon "trash.xpm"
Index: wl/wl-version.el
===================================================================
RCS file: /cvs/root/wanderlust/wl/wl-version.el,v
retrieving revision 1.29.2.2
retrieving revision 1.29.2.3
diff -u -r1.29.2.2 -r1.29.2.3
--- wl/wl-version.el	25 Mar 2005 14:45:10 -0000	1.29.2.2
+++ wl/wl-version.el	1 Apr 2005 12:42:37 -0000	1.29.2.3
@@ -46,7 +46,7 @@
    "Wanderlust" nil
    (eval-when-compile
      (product-version (product-find 'elmo-version))) ; equals to ELMO version.
-   "Africa"))
+   "Bad Medicine-pre"))
 
 (defconst wl-version-status nil
   "Wanderlust verstion status.  For override default rule.
Index: wl/wl-xmas.el
===================================================================
RCS file: /cvs/root/wanderlust/wl/wl-xmas.el,v
retrieving revision 1.42
retrieving revision 1.42.4.1
diff -u -r1.42 -r1.42.4.1
--- wl/wl-xmas.el	1 Sep 2004 15:26:35 -0000	1.42
+++ wl/wl-xmas.el	3 Apr 2005 06:16:23 -0000	1.42.4.1
@@ -383,6 +383,7 @@
     (wl-folder-nmz-glyph	. wl-nmz-folder-icon)
     (wl-folder-shimbun-glyph	. wl-shimbun-folder-icon)
     (wl-folder-file-glyph	. wl-file-folder-icon)
+    (wl-folder-access-glyph	. wl-access-folder-icon)
     (wl-folder-trash-empty-glyph . wl-empty-trash-folder-icon)
     (wl-folder-draft-glyph	. wl-draft-folder-icon)
     (wl-folder-queue-glyph	. wl-queue-folder-icon)
